## okteta 0.26.24

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)

project(Okteta VERSION 0.26.24)

set(REQUIRED_KF5_VERSION "5.48.0")
find_package(ECM ${REQUIRED_KF5_VERSION} REQUIRED NO_MODULE)

set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake ${ECM_MODULE_PATH})

# ECM KDE macros (include first, to have their policies and settings effect all other macros)
include(KDEInstallDirs)
include(KDECMakeSettings NO_POLICY_SCOPE)
include(KDECompilerSettings NO_POLICY_SCOPE)
# ECM macros
include(ECMInstallIcons)
include(ECMAddAppIcon)
# CMake macros
include(FeatureSummary)
include(CMakeDependentOption)
if(BUILD_TESTING)
  include(ECMAddTests)
endif()
# Okteta macros
include(OktetaInternalMacros)

# control build scope, default to examples if BUILD_TESTING is ON
if( NOT DEFINED OMIT_EXAMPLES AND NOT BUILD_TESTING )
    set( OMIT_EXAMPLES TRUE )
endif()
if( NOT DEFINED OMIT_INTERNAL_TEMPLATES AND NOT BUILD_TESTING )
    set( OMIT_INTERNAL_TEMPLATES TRUE )
endif()

if( NOT OMIT_EXAMPLES )
    set( OKTETA_BUILD_EXAMPLES TRUE )
endif()
if( NOT OMIT_INTERNAL_TEMPLATES )
    set( KASTEN_BUILD_INTERNAL_TEMPLATES TRUE )
endif()

option(BUILD_DESIGNERPLUGIN "Build the Designer plugin." ON)
add_feature_info(DESIGNERPLUGIN ${BUILD_DESIGNERPLUGIN} "Qt Designer plugin")
option(BUILD_OKTETAKASTENLIBS "Build the Okteta Kasten libraries." ON)
add_feature_info(OKTETAKASTENLIBS ${BUILD_OKTETAKASTENLIBS} "Okteta Kasten libraries")
cmake_dependent_option(BUILD_TERMINALTOOL "Build the Terminal tool (needs Konsole/Qt5 KPart)." ON "BUILD_OKTETAKASTENLIBS" OFF)
add_feature_info(TERMINALTOOL ${BUILD_TERMINALTOOL} "Terminal tool")

cmake_dependent_option(BUILD_KPARTSPLUGIN "Build the KParts plugin." ON "BUILD_OKTETAKASTENLIBS" OFF)
add_feature_info(KPARTSPLUGIN ${BUILD_KPARTSPLUGIN} "KParts plugin")
cmake_dependent_option(BUILD_DESKTOPPROGRAM "Build the program." ON "BUILD_OKTETAKASTENLIBS" OFF)
add_feature_info(DESKTOPPROGRAM ${BUILD_DESKTOPPROGRAM} "Program")

set(REQUIRED_QT_VERSION "5.9.0")
set(ADDITIONAL_REQUIRED_QT_COMPONENTS)
if(BUILD_TESTING)
    list(APPEND ADDITIONAL_REQUIRED_QT_COMPONENTS Test)
endif()
if( BUILD_DESIGNERPLUGIN )
    list(APPEND ADDITIONAL_REQUIRED_QT_COMPONENTS UiPlugin)
endif()
if( BUILD_OKTETAKASTENLIBS )
    list(APPEND ADDITIONAL_REQUIRED_QT_COMPONENTS
        Network
        PrintSupport
        Qml
        Script
        ScriptTools
        Xml
    )
endif()
find_package(Qt5 ${REQUIRED_QT_VERSION} CONFIG REQUIRED
    COMPONENTS
    Core
    Widgets
    ${ADDITIONAL_REQUIRED_QT_COMPONENTS}
)

set(ADDITIONAL_REQUIRED_KF_COMPONENTS)
if( BUILD_OKTETAKASTENLIBS )
    list(APPEND ADDITIONAL_REQUIRED_KF_COMPONENTS
        Bookmarks
        Completion
        IconThemes
        KCMUtils
        KIO
        NewStuff
        Service
        WidgetsAddons
        XmlGui
    )
endif()
if (BUILD_TERMINALTOOL OR BUILD_KPARTSPLUGIN)
    list(APPEND ADDITIONAL_REQUIRED_KF_COMPONENTS
        Parts
    )
endif()
if( BUILD_DESKTOPPROGRAM )
    list(APPEND ADDITIONAL_REQUIRED_KF_COMPONENTS
        Crash
        DBusAddons
        DocTools
    )
endif()
find_package(KF5 ${REQUIRED_KF5_VERSION} REQUIRED
    COMPONENTS
    Codecs
    ConfigWidgets
    I18n
    ${ADDITIONAL_REQUIRED_KF_COMPONENTS}
)

find_package(Qca-qt5 2.1.0)
set_package_properties(Qca-qt5 PROPERTIES
    DESCRIPTION "Qt Cryptographic Architecture"
    URL "https://commits.kde.org/qca"
    TYPE OPTIONAL
    PURPOSE "Needed for most of the algorithms of the checksum tool"
)

add_definitions(
    -DQT_DEPRECATED_WARNINGS
    -DQT_DISABLE_DEPRECATED_BEFORE=0x050900
    -DQT_USE_QSTRINGBUILDER
    -DQT_NO_CAST_TO_ASCII
    -DQT_NO_CAST_FROM_ASCII
    -DQT_NO_CAST_FROM_BYTEARRAY
    -DQT_STRICT_ITERATORS
    -DQT_NO_URL_CAST_FROM_STRING
    -DQT_NO_SIGNALS_SLOTS_KEYWORDS
    -DQT_NO_NARROWING_CONVERSIONS_IN_CONNECT
)

# helper libs
add_subdirectory( libs )
if( BUILD_DESKTOPPROGRAM )
    add_subdirectory( doc )
endif()

set( OKTETALIBS_MAJOR_VERSION 0 )
set( OKTETALIBS_MINOR_VERSION 10 )
set( OKTETALIBS_PATCHLEVEL_VERSION 0 )
set( OKTETALIBS_VERSION "${OKTETALIBS_MAJOR_VERSION}.${OKTETALIBS_MINOR_VERSION}.${OKTETALIBS_PATCHLEVEL_VERSION}" )
set( OKTETALIBS_ABI_VERSION 3 )

set( OKTETALIBS_LIB_SOVERSION 0 )
set( OKTETALIBS_LIB_VERSION ${OKTETALIBS_VERSION} )

# Okteta libs
add_subdirectory( core )
add_subdirectory( gui )

if( BUILD_DESIGNERPLUGIN )
    add_subdirectory( designer )
endif()

# Okteta Kasten components
if( BUILD_OKTETAKASTENLIBS )
    add_subdirectory( kasten )
endif()
# special mimetypes
if( BUILD_OKTETAKASTENLIBS )
    add_subdirectory( mimetypes )
endif()

# programs and parts for desktop
add_subdirectory( parts )
if( BUILD_DESKTOPPROGRAM )
    add_subdirectory( program )
endif()

ki18n_install(po)

if( BUILD_DESKTOPPROGRAM )
    kdoctools_install(po)
endif()

feature_summary(WHAT ALL INCLUDE_QUIET_PACKAGES FATAL_ON_MISSING_REQUIRED_PACKAGES)

=== gui/CMakeLists.txt ===
set(OKTETAGUI_VERSION ${OKTETALIBS_LIB_VERSION})
set(OKTETAGUI_SO_VERSION ${OKTETALIBS_LIB_SOVERSION})

set(LIBOKTETAWIDGETS_REL_DIR ../kasten/gui/liboktetawidgets)

add_definitions(-DTRANSLATION_DOMAIN=\"liboktetagui\")

macro(OKTETAGUI_ADD_SUBLIBRARY _subdir)
    okteta_add_sublibrary(Gui NAMESPACE Okteta
        SUBDIR ${_subdir}
        ${ARGN}
    )
endmacro()

oktetagui_add_sublibrary(controller
    PRIVATE
        AbstractController
        AbstractMouseController
        AbstractWheelController
        AbstractEditor
        KeyNavigator
        TabController
        ClipboardController
        UndoRedoController
        CharEditor
        ValueEditor
        MouseNavigator
        MousePaster
        TapNavigator
        # Dragger
        ZoomWheelController
        ZoomPinchController
        Dropper

        TouchOnlyTapAndHoldGesture
        TouchOnlyTapAndHoldGestureRecognizer
)

oktetagui_add_sublibrary(libcolumnsview
    PUBLIC
        AbstractColumnStylist
        AbstractColumnRenderer
        ColumnsView
        PixelMetrics # TODO: this header needs to be redone
)

# TODO: move to oktetacore, no longer duplicate
oktetagui_add_sublibrary(${LIBOKTETAWIDGETS_REL_DIR}
    PRIVATE
        ByteArrayChar8StringDecoder
        ByteArrayValueStringDecoder
)

okteta_add_sublibrary(Gui  NAMESPACE Okteta
    PUBLIC
        OktetaGui

        LinePosition
        Line
        LinePositionRange
        LineRange

        Coord
        CoordRange
        CoordRangeList
        Selection

        AbstractByteArrayColumnRenderer
        CharByteArrayColumnRenderer
        ValueByteArrayColumnRenderer
        ByteArrayRowColumnRenderer
        OffsetColumnRenderer
        BorderColumnRenderer

        AbstractByteArrayView
        ByteArrayColumnView

        OffsetFormat
        ByteArrayTableRanges
        ByteArrayRowView
        ByteArrayTableLayout
        WidgetColumnStylist

    PRIVATE
        ByteArrayTableCursor
        Cursor
        FontScalingZoomState
)


okteta_add_library(Gui NAMESPACE Okteta
    PUBLIC
        OktetaCore
        Qt5::Widgets
    PRIVATE
        KF5::I18n
        KF5::ConfigWidgets
    VERSION     ${OKTETAGUI_VERSION}
    SOVERSION   ${OKTETAGUI_SO_VERSION}
    ABIVERSION  ${OKTETALIBS_ABI_VERSION}
    SOURCES   ${oktetagui_LIB_SRCS}
    HEADERS   ${oktetagui_LIB_HDRS}
    CCHEADERS ${oktetagui_LIB_CCHDRS}
    NO_TARGET_NAMESPACE
    NO_VERSIONED_INCLUDEDIR
    NO_VERSIONED_PACKAGE_NAME
)

target_include_directories(OktetaGui
    PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/libcolumnsview>
    PRIVATE
        ${LIBOKTETAWIDGETS_REL_DIR}
)

okteta_add_cmakeconfig(Gui NAMESPACE Okteta
)

okteta_add_qmakeconfig(Gui NAMESPACE Okteta
    DEPS OktetaCore widgets
)

okteta_add_pkgconfig(Gui NAMESPACE Okteta
    DEPS OktetaCore Qt5Widgets
    DESCRIPTION "Okteta Gui"
)

if(BUILD_TESTING)
    add_subdirectory(tests)
#   add_library( testoktetacore STATIC ${oktetagui_LIB_SRCS} )
endif()

=== kasten/CMakeLists.txt ===
set( KASTEN_LIB_VERSION 0.4.0 )
set( KASTEN_ABI_VERSION 4 )

set( OKTETAKASTEN_MAJOR_VERSION 0 )
set( OKTETAKASTEN_MINOR_VERSION 4 )
set( OKTETAKASTEN_PATCHLEVEL_VERSION 0 )
set( OKTETAKASTEN_VERSION "${OKTETAKASTEN_MAJOR_VERSION}.${OKTETAKASTEN_MINOR_VERSION}.${OKTETAKASTEN_PATCHLEVEL_VERSION}" )
set( OKTETAKASTEN_ABI_VERSION 2 )

set( OKTETAKASTEN_LIB_SOVERSION 0 )
set( OKTETAKASTEN_LIB_VERSION ${OKTETAKASTEN_VERSION} )


add_subdirectory( core )
add_subdirectory( gui )
add_subdirectory( controllers )

=== libs/CMakeLists.txt ===
if( BUILD_OKTETAKASTENLIBS )
    add_subdirectory( kasten )
endif()

=== parts/CMakeLists.txt ===
if( BUILD_KPARTSPLUGIN )
    add_subdirectory( kpart )
endif()

=== program/CMakeLists.txt ===
set( okteta_SRCS
  main.cpp
  program.cpp
  about.cpp
  mainwindow.cpp
)

configure_file(about-config.hpp.in ${CMAKE_CURRENT_BINARY_DIR}/about-config.hpp @ONLY)
set(KASTEN_BUILD_TERMINALTOOL ${BUILD_TERMINALTOOL})
configure_file(mainwindow-config.hpp.in ${CMAKE_CURRENT_BINARY_DIR}/mainwindow-config.hpp @ONLY)

qt5_add_resources(okteta_SRCS
    okteta.qrc
)

ecm_add_app_icon(okteta_SRCS
  ICONS
    ${CMAKE_CURRENT_SOURCE_DIR}/16-apps-okteta.png
    ${CMAKE_CURRENT_SOURCE_DIR}/22-apps-okteta.png
    ${CMAKE_CURRENT_SOURCE_DIR}/32-apps-okteta.png
    ${CMAKE_CURRENT_SOURCE_DIR}/48-apps-okteta.png
    ${CMAKE_CURRENT_SOURCE_DIR}/64-apps-okteta.png
    ${CMAKE_CURRENT_SOURCE_DIR}/128-apps-okteta.png
)

add_executable( okteta  ${okteta_SRCS} )

target_link_libraries( okteta
  OktetaKastenControllers
  OktetaKastenGui
  OktetaKastenCore
  KastenControllers
  KastenGui
  KastenCore
  KF5::ConfigCore
  KF5::I18n
  KF5::XmlGui
  KF5::DBusAddons
  KF5::Crash
)

install( TARGETS okteta  ${KDE_INSTALL_TARGETS_DEFAULT_ARGS} )


install( PROGRAMS org.kde.okteta.desktop  DESTINATION ${KDE_INSTALL_APPDIR} )
install( FILES org.kde.okteta.appdata.xml DESTINATION ${KDE_INSTALL_METAINFODIR} )

ecm_install_icons(
  ICONS
    16-apps-okteta.png
    22-apps-okteta.png
    32-apps-okteta.png
    48-apps-okteta.png
    64-apps-okteta.png
    128-apps-okteta.png
  DESTINATION ${KDE_INSTALL_ICONDIR}
)

=== core/tests/CMakeLists.txt ===
set(SUTDIR ${CMAKE_CURRENT_SOURCE_DIR}/..)

add_library(OktetaCoreSourcesTestShim INTERFACE)
target_include_directories(OktetaCoreSourcesTestShim INTERFACE
  ${SUTDIR}
  ${CMAKE_CURRENT_BINARY_DIR}/.. # for oktetacore_export.hpp
)
# Configure export macros to be setup as with a static lib
# as the source files are reused for the tests.
# Saves doing a separate export header.
target_compile_definitions(OktetaCoreSourcesTestShim INTERFACE
  -DOKTETACORE_STATIC_DEFINE
)

# helper
set( OktetaCoreTestUtil_LIB_SRCS
  util/fill.cpp
)

add_library( OktetaCoreTestUtil  STATIC ${OktetaCoreTestUtil_LIB_SRCS} )
target_link_libraries( OktetaCoreTestUtil
  PUBLIC
    OktetaCore
    Qt5::Core
)

# variant for static version of OktetaCore
add_library(TestOktetaCoreTestUtil STATIC ${OktetaCoreTestUtil_LIB_SRCS})
target_link_libraries(TestOktetaCoreTestUtil
  PUBLIC
    OktetaCoreSourcesTestShim
    Qt5::Core
)

ecm_add_test(
  arraychangemetricstest.cpp
#  ${CMAKE_CURRENT_SOURCE_DIR}/../arraychangemetrics.cpp
  TEST_NAME arraychangemetricstest
  NAME_PREFIX libokteta-core-
  LINK_LIBRARIES OktetaCoreSourcesTestShim Qt5::Test
)


ecm_add_test(
  addressrangetest.cpp
  TEST_NAME addressrangetest
  NAME_PREFIX libokteta-core-
  LINK_LIBRARIES TestOktetaCore Qt5::Test
)


ecm_add_test(
  addressrangelisttest.cpp
  TEST_NAME addressrangelisttest
  NAME_PREFIX libokteta-core-
  LINK_LIBRARIES TestOktetaCore Qt5::Test
)


ecm_add_test(
  fixedsizebytearraymodeltest.cpp
  TEST_NAME fixedsizebytearraymodeltest
  NAME_PREFIX libokteta-core-
  LINK_LIBRARIES TestOktetaCore Qt5::Test
)


ecm_add_test(
  abstractbytearraymodeliftest.cpp
  fixedsizebytearraymodelabstractbytearraymodeliftest.cpp
  TEST_NAME fixedsizebytearraymodelabstractbytearraymodeliftest
  NAME_PREFIX libokteta-core-
  LINK_LIBRARIES TestOktetaCoreTestUtil TestOktetaCore Qt5::Test
)


ecm_add_test(
  bytearraymodeltest.cpp
  TEST_NAME bytearraymodeltest
  NAME_PREFIX libokteta-core-
  LINK_LIBRARIES OktetaCore Qt5::Test
)


ecm_add_test(
  abstractbytearraymodeliftest.cpp
  bytearraymodelabstractbytearraymodeliftest.cpp
  TEST_NAME bytearraymodelabstractbytearraymodeliftest
  NAME_PREFIX libokteta-core-
  LINK_LIBRARIES TestOktetaCoreTestUtil TestOktetaCore Qt5::Test
)


ecm_add_test(
  abstractbytearraymodeliftest.cpp
  piecetablebytearraymodelabstractbytearraymodeliftest.cpp
  TEST_NAME piecetablebytearraymodelabstractbytearraymodeliftest
  NAME_PREFIX libokteta-core-
  LINK_LIBRARIES TestOktetaCoreTestUtil TestOktetaCore Qt5::Test
)


ecm_add_test(
  versionableiftest.cpp
  piecetablebytearraymodelversionableiftest.cpp
  TEST_NAME piecetablebytearraymodelversionableiftest
  NAME_PREFIX libokteta-core-
  LINK_LIBRARIES OktetaCoreTestUtil OktetaCore Qt5::Test
)


ecm_add_test(
  valuecodectest.cpp
  TEST_NAME valuecodectest
  NAME_PREFIX libokteta-core-
  LINK_LIBRARIES OktetaCore Qt5::Test
)


ecm_add_test(
  charcodectest.cpp
  TEST_NAME charcodectest
  NAME_PREFIX libokteta-core-
  LINK_LIBRARIES OktetaCore Qt5::Test
)


ecm_add_test(
  textcharcodectest.cpp
  TEST_NAME textcharcodectest
  NAME_PREFIX libokteta-core-
  LINK_LIBRARIES TestOktetaCore Qt5::Test KF5::Codecs
)


ecm_add_test(
  charcodeciftest.cpp
  textcharcodeccharcodeciftest.cpp
  TEST_NAME textcharcodeccharcodeciftest
  NAME_PREFIX libokteta-core-
  LINK_LIBRARIES TestOktetaCore Qt5::Test KF5::Codecs
)


ecm_add_test(
  charcodeciftest.cpp ebcdic1047charcodeccharcodeciftest.cpp
  TEST_NAME ebcdic1047charcodeccharcodeciftest
  NAME_PREFIX libokteta-core-
  LINK_LIBRARIES TestOktetaCore Qt5::Test
)


ecm_add_test(
  bookmarktest.cpp
  TEST_NAME bookmarktest
  NAME_PREFIX libokteta-core-
  LINK_LIBRARIES OktetaCoreSourcesTestShim Qt5::Test
)


ecm_add_test(
  bookmarklisttest.cpp
  TEST_NAME bookmarklisttest
  NAME_PREFIX libokteta-core-
  LINK_LIBRARIES TestOktetaCore Qt5::Test
)

=== designer/examples/CMakeLists.txt ===
set( oktetadesignerexamplewidget_SRCS
  main.cpp
)

qt5_wrap_ui( oktetadesignerexamplewidget_SRCS example_widget.ui )

add_executable( oktetadesignerexample  ${oktetadesignerexamplewidget_SRCS} )

target_link_libraries( oktetadesignerexample
  OktetaGui
  OktetaCore
  Qt5::Widgets
)

=== gui/tests/CMakeLists.txt ===
set( SUTDIR ${CMAKE_CURRENT_SOURCE_DIR}/.. )

add_library(OktetaGuiSourcesTestShim INTERFACE)
target_include_directories(OktetaGuiSourcesTestShim INTERFACE
  ${SUTDIR}
  ${CMAKE_CURRENT_BINARY_DIR}/..
)
# Configure export macros to be setup as with a static lib
# as the source files are reused for the tests.
# Saves doing a separate export header.
target_compile_definitions(OktetaGuiSourcesTestShim INTERFACE
  -DOKTETAGUI_STATIC_DEFINE
)

ecm_add_test(
  selectiontest.cpp
  TEST_NAME selectiontest
  NAME_PREFIX libokteta-gui-
  LINK_LIBRARIES OktetaGuiSourcesTestShim OktetaCore Qt5::Test )

ecm_add_test(
  coordtest.cpp
  TEST_NAME coordtest
  NAME_PREFIX libokteta-gui-
  LINK_LIBRARIES OktetaGuiSourcesTestShim OktetaCore Qt5::Test )


ecm_add_test(
  coordrangetest.cpp
  TEST_NAME coordrangetest
  NAME_PREFIX libokteta-gui-
  LINK_LIBRARIES OktetaGuiSourcesTestShim OktetaCore Qt5::Test )


ecm_add_test(
  ${SUTDIR}/coordrangelist.cpp
  coordrangelisttest.cpp
  TEST_NAME coordrangelisttest
  NAME_PREFIX libokteta-gui-
  LINK_LIBRARIES OktetaGuiSourcesTestShim OktetaCore Qt5::Test )


ecm_add_test(
  ${SUTDIR}/bytearraytablelayout.cpp
  bytearraytablelayouttest.cpp
  TEST_NAME bytearraytablelayouttest
  NAME_PREFIX libokteta-gui-
  LINK_LIBRARIES OktetaGuiSourcesTestShim OktetaCore Qt5::Test )


ecm_add_test(
  ${SUTDIR}/bytearraytablecursor.cpp
  ${SUTDIR}/bytearraytablelayout.cpp
  bytearraytablecursortest.cpp
  TEST_NAME bytearraytablecursortest
  NAME_PREFIX libokteta-gui-
  LINK_LIBRARIES OktetaGuiSourcesTestShim OktetaCore Qt5::Test )

ecm_add_test(
    ${SUTDIR}/fontscalingzoomstate.cpp
    fontscalingzoomstatetest.cpp
    TEST_NAME fontscalingzoomstatetest
    NAME_PREFIX libokteta-gui-
    LINK_LIBRARIES OktetaGuiSourcesTestShim Qt5::Gui Qt5::Test
)

ecm_add_test(
    abstractbytearrayviewiftest.cpp
    bytearrayrowviewabstractbytearrayviewiftest.cpp
    TEST_NAME bytearrayrowviewabstractbytearrayviewiftest
    NAME_PREFIX libokteta-gui-
    LINK_LIBRARIES OktetaGui Qt5::Test
)

ecm_add_test(
    abstractbytearrayviewiftest.cpp
    bytearraycolumnviewabstractbytearrayviewiftest.cpp
    TEST_NAME bytearraycolumnviewabstractbytearrayviewiftest
    NAME_PREFIX libokteta-gui-
    LINK_LIBRARIES OktetaGui Qt5::Test
)

=== kasten/controllers/CMakeLists.txt ===
set(OKTETAKASTENCONTROLLERS_VERSION ${OKTETAKASTEN_LIB_VERSION})
set(OKTETAKASTENCONTROLLERS_SO_VERSION ${OKTETAKASTEN_LIB_SOVERSION})

set( LIBFRAMESPRINT_REL_DIR ../../libs/framesprint )

add_definitions(-DTRANSLATION_DOMAIN=\"liboktetakasten\")

set(HAVE_QCA2 ${Qca-qt5_FOUND})
configure_file(config-qca2.hpp.in  ${CMAKE_CURRENT_BINARY_DIR}/config-qca2.hpp)

macro(OKTETAKASTENCONTROLLERS_ADD_SUBLIBRARY _subdir)
    okteta_add_sublibrary(Controllers NAMESPACE Okteta Kasten
        REVERSE_NAMESPACE_INCLUDEDIR
        SUBDIR ${_subdir}
        ${ARGN}
    )
endmacro()

oktetakastencontrollers_add_sublibrary(libconfigentries
    PRIVATE
        AddressComboBoxCodingConfigEntry
        ByteArrayCodingConfigEntry
        ByteArrayComboBoxCodingConfigEntry
        CaseSensitivityConfigEntry
        DirectionConfigEntry
        EndiannessConfigEntry
        FindDirectionConfigEntry
)

oktetakastencontrollers_add_sublibrary(document/info
    PUBLIC
        DocumentInfoToolFactory
        DocumentInfoToolViewFactory
    PRIVATE
        ByteArrayModelIoDevice
        DocumentInfoView
        DocumentInfoTool
        DocumentInfoToolView
)

# unused, TODO: remove?
if (FALSE)
oktetakastencontrollers_add_sublibrary(document/overwriteonly
    PUBLIC
        OverwriteOnlyControllerFactory
    PRIVATE
        OverwriteOnlyController
)
endif()

oktetakastencontrollers_add_sublibrary(view/overwritemode
    PUBLIC
        OverwriteModeControllerFactory
    PRIVATE
        OverwriteModeController
)
oktetakastencontrollers_add_sublibrary(view/info
    PUBLIC
        InfoToolFactory
        InfoToolViewFactory
    PRIVATE
        CreateStatisticJob
        StatisticDisplayModel
        StatisticTableModel
        InfoView
        InfoTool
        InfoToolView
    KCFG
        infoviewsettings.kcfgc
)
configure_file(view/info/statisticdisplaymodel-config.hpp.in ${CMAKE_CURRENT_BINARY_DIR}/statisticdisplaymodel-config.hpp @ONLY)

oktetakastencontrollers_add_sublibrary(view/stringsextract
    PUBLIC
        StringsExtractToolFactory
        StringsExtractToolViewFactory
    PRIVATE
        ExtractStringsJob
        ContainedStringTableModel
        StringsExtractView
        ContainedString
        StringsExtractTool
        StringsExtractToolView
)

oktetakastencontrollers_add_sublibrary(view/libbytearraychecksum
    PRIVATE
        AbstractByteArrayChecksumAlgorithm
        AbstractByteArrayChecksumParameterSet
        AbstractByteArrayChecksumParameterSetEdit
        ByteArrayChecksumAlgorithmFactory
        ByteArrayChecksumParameterSetEditFactory
)
if( Qca-qt5_FOUND )
    set( QCA2CHECKSUM_CLASSES
        Qca2ByteArrayChecksumAlgorithm
    )
endif()
oktetakastencontrollers_add_sublibrary(view/libbytearraychecksum/algorithm
    PRIVATE
        Crc32ByteArrayChecksumAlgorithm
        Crc64ByteArrayChecksumAlgorithm
        Adler32ByteArrayChecksumAlgorithm
        ModSum8ByteArrayChecksumAlgorithm
        ModSum16ByteArrayChecksumAlgorithm
        ModSum32ByteArrayChecksumAlgorithm
        ModSum64ByteArrayChecksumAlgorithm
## NEWCHECKSUM(start)
## Here add the names of your classes of your checksum algorithm,
## e.g.
##         MyByteArrayChecksumAlgorithm
## NEWCHECKSUM(end)
        NoByteArrayChecksumParameterSet
        NoByteArrayChecksumParameterSetEdit
        ModSumByteArrayChecksumParameterSet
        ModSumByteArrayChecksumParameterSetEdit
        Crc64ByteArrayChecksumParameterSet
        Crc64ByteArrayChecksumParameterSetEdit
## NEWCHECKSUMPARAMETERSET(start)
## Here add the names of your classes of your checksum parameter set and
## of the widget to edit the checksum parameter set,
## e.g.
##         MyByteArrayChecksumParameterSet
##         MyByteArrayChecksumParameterSetEdit
## NEWCHECKSUMPARAMETERSET(end)
        ${QCA2CHECKSUM_CLASSES}
)

oktetakastencontrollers_add_sublibrary(view/checksum
    PUBLIC
        ChecksumToolFactory
        ChecksumToolViewFactory
    PRIVATE
        ChecksumCalculateJob
        ChecksumLogging
        ChecksumView
        ChecksumTool
        ChecksumToolView
)

oktetakastencontrollers_add_sublibrary(view/libfinddialog
    PUBLIC
        FindDirection
    PRIVATE
        AbstractFindDialog
)

oktetakastencontrollers_add_sublibrary(view/libbytearraysearch
    PRIVATE
        ByteArraySearchJob
        ByteArraySearchUtils
)

oktetakastencontrollers_add_sublibrary(view/poddecoder/typecodecs
    PRIVATE
        Binary8Codec
        Octal8Codec
        Hexadecimal8Codec
        UInt8Codec
        UInt16Codec
        UInt32Codec
        UInt64Codec
        SInt8Codec
        SInt16Codec
        SInt32Codec
        SInt64Codec
        Float32Codec
        Float64Codec
        Char8Codec
        Utf8Codec
)

oktetakastencontrollers_add_sublibrary(view/poddecoder
    PUBLIC
        PODDecoderToolFactory
        PODDecoderToolViewFactory
    PRIVATE
        PODData
        PODDisplayModel
        PODTableModel
        PODDelegate
        PODTableView
        PODDecoderTool
        PODDecoderToolView
)

oktetakastencontrollers_add_sublibrary(view/poddecoder/types
    SOURCE_TAG typeeditor
    PRIVATE
        Char8
)

oktetakastencontrollers_add_sublibrary(view/poddecoder/typeeditors
    SOURCE_TAG typeeditor
    PRIVATE
        AbstractValue8Editor
        Binary8Editor
        Octal8Editor
        Hexadecimal8Editor
        UIntSpinBox
        SIntSpinBox
        Float32Editor
        Float64Editor
        Char8Editor
        Char8StringParser
        Char8StringValidator
        Utf8Editor
)

oktetakastencontrollers_add_sublibrary(view/bytetable
    PUBLIC
        ByteTableToolFactory
        ByteTableToolViewFactory
    PRIVATE
        ByteTableModel
        ByteTableView
        ByteTableTool
        ByteTableToolView
    KCFG
        bytetableviewsettings.kcfgc
)

oktetakastencontrollers_add_sublibrary(view/search
    PUBLIC
        SearchControllerFactory
    PRIVATE
        SearchUserQueryable
        SearchDialog
        SearchTool
        SearchController
)

oktetakastencontrollers_add_sublibrary(view/replace
    PUBLIC
        ReplaceControllerFactory
    PRIVATE
        ReplaceUserQueryable
        ReplaceController
        ReplaceDialog
        ReplacePrompt
        ReplaceJob
        ReplaceTool
)

oktetakastencontrollers_add_sublibrary(view/libbytearrayfilter
    PRIVATE
        AbstractByteArrayFilter
        AbstractByteArrayFilterParameterSet
        AbstractByteArrayFilterParameterSetEdit
        ByteArrayFilterFactory
        ByteArrayFilterParameterSetEditFactory
)

oktetakastencontrollers_add_sublibrary(view/libbytearrayfilter/filter
    PRIVATE
        NoByteArrayFilterParameterSet
        OperandByteArrayFilterParameterSet
        ReverseByteArrayFilterParameterSet
        RotateByteArrayFilterParameterSet
## NEWFILTERPARAMETERSET(start)
## Here add the names of your classes of your filter parameter set,
## e.g.
##         MyByteArrayFilterParameterSet
## NEWFILTERPARAMETERSET(end)
        AndByteArrayFilter
        OrByteArrayFilter
        XorByteArrayFilter
        InvertByteArrayFilter
        ReverseByteArrayFilter
        RotateByteArrayFilter
        ShiftByteArrayFilter
## NEWFILTER(start)
## Here add the names of your classes of your filter,
## e.g.
##         MyByteArrayFilter
## NEWFILTER(end)
        NoByteArrayFilterParameterSetedit
        OperandByteArrayFilterParameterSetedit
        ReverseByteArrayFilterParameterSetedit
        RotateByteArrayFilterParameterSetedit
## NEWFILTERPARAMETERSET(start)
## Here add the names of your classes of your widget to edit the filter parameter set,
## e.g.
##         MyByteArrayFilterParameterSetedit
## NEWFILTERPARAMETERSET(end)
)
oktetakastencontrollers_add_sublibrary(view/filter
    PUBLIC
        FilterToolFactory
        FilterToolViewFactory
    PRIVATE
        FilterJob
        FilterView
        FilterTool
        FilterToolView
)

oktetakastencontrollers_add_sublibrary(view/charsetconversion
    PUBLIC
        CharsetConversionToolFactory
        CharsetConversionToolViewFactory
    PRIVATE
        CharsetConversionJob
        CharsetConversionView
        CharsetConversionTool
        CharsetConversionToolView
)

oktetakastencontrollers_add_sublibrary(view/gotooffset
    PUBLIC
        GotoOffsetControllerFactory
    PRIVATE
        GotoOffsetTool
        GotoOffsetView
        GotoOffsetToolView
        GotoOffsetController
)

oktetakastencontrollers_add_sublibrary(view/selectrange
    PUBLIC
        SelectRangeControllerFactory
    PRIVATE
        SelectRangeTool
        SelectRangeView
        SelectRangeToolView
        SelectRangeController
)

oktetakastencontrollers_add_sublibrary(view/bookmarks
    PUBLIC
        BookmarksControllerFactory
    PRIVATE
        BookmarkEditPopup
        BookmarksController
)

oktetakastencontrollers_add_sublibrary(view/bookmarks
    PUBLIC
        BookmarksToolFactory
        BookmarksToolViewFactory
    PRIVATE
        BookmarkListModel
        BookmarksView
        BookmarksTool
        BookmarksToolView
)


oktetakastencontrollers_add_sublibrary(view/structures/datatypes
    SOURCE_TAG structuresdatatypes
    PRIVATE
        TopLevelDataInformation
        DataInformation
        DataInformationbase
        DummyDataInformation
        DataInformationwithchildren
        StructureDataInformation
        TaggedUnionDataInformation
        UnionDataInformation
        PrimitiveFactory
        PrimitiveDataType
)

oktetakastencontrollers_add_sublibrary(view/structures/datatypes/array
    SOURCE_TAG structuresdatatypes
    PRIVATE
        ArrayDataInformation
        AbstractArrayData
        ComplexArrayData
        PrimitiveArrayData
)

oktetakastencontrollers_add_sublibrary(view/structures/datatypes/primitive
    SOURCE_TAG structuresdatatypes
    PRIVATE
        PointerDataInformation
        CharDataInformation
        DoubleDataInformation
        FloatDataInformation
        SIntDataInformation
        UIntDataInformation
        BoolDataInformation
        FlagDataInformation
        PrimitiveDataInformation
        BasicPrimitiveDataInformation
        EnumDataInformation
        EnumDefinition
)

oktetakastencontrollers_add_sublibrary(view/structures/datatypes/primitive/bitfield
    SOURCE_TAG structuresdatatypes
    PRIVATE
        AbstractBitfieldDataInformation
        BoolBitfieldDataInformation
        SignedBitfieldDataInformation
        UnsignedBitfieldDataInformation
)

oktetakastencontrollers_add_sublibrary(view/structures/datatypes/strings
    SOURCE_TAG structuresdatatypes
    PRIVATE
        StringDataInformation
        StringData
        AsciiStringData
        Latin1StringData
        Utf8StringData
        Utf16StringData
        Utf32StringData
        EbcdicStringData
)
oktetakastencontrollers_add_sublibrary(../../core/codecs
    SOURCE_TAG structuresdatatypes
    PRIVATE
        Ebcdic1047CharCodec
)

oktetakastencontrollers_add_sublibrary(view/structures/script
    SOURCE_TAG structuresdatatypes
    PRIVATE
        ScriptEngineInitializer
        ScriptHandler
        ScriptHandlerInfo
        ScriptLogger
        ScriptLoggerView
        SafeReference
)

oktetakastencontrollers_add_sublibrary(view/structures/script/classes
    SOURCE_TAG structuresdatatypes
    PRIVATE
        DefaultScriptClass
        ArrayScriptClass
        PrimitiveScriptClass
        EnumScriptClass
        PointerScriptClass
        BitfieldScriptClass
        StringScriptClass
        StructUnionScriptClass
)

oktetakastencontrollers_add_sublibrary(view/structures/parsers
    SOURCE_TAG structuresdatatypes
    PRIVATE
        AbstractStructureParser
        OsdParser
        ScriptFileParser
        ScriptValueConverter
        DataInformationFactory
        ParserUtils
)

oktetakastencontrollers_add_sublibrary(view/structures/settings
    SOURCE_TAG structuresdatatypes
    KCFG
        structureviewpreferences.kcfgc
)

oktetakastencontrollers_add_sublibrary(view/structures
    SOURCE_TAG structuresdatatypes
    PRIVATE

=== kasten/core/CMakeLists.txt ===
set(OKTETAKASTENCORE_VERSION ${OKTETAKASTEN_LIB_VERSION})
set(OKTETAKASTENCORE_SO_VERSION ${OKTETAKASTEN_LIB_SOVERSION})

set(LIBOKTETAWIDGETS_REL_DIR ../gui/liboktetawidgets)

add_definitions(-DTRANSLATION_DOMAIN=\"liboktetakasten\")

macro(OKTETAKASTENCORE_ADD_SUBLIBRARY _subdir)
    okteta_add_sublibrary(Core NAMESPACE Okteta Kasten
        REVERSE_NAMESPACE_INCLUDEDIR
        SUBDIR ${_subdir}
        ${ARGN}
    )
endmacro()

oktetakastencore_add_sublibrary(document
    PUBLIC
        ByteArrayDocument
        ByteArrayDocumentFactory
        ByteArraySelection
)

oktetakastencore_add_sublibrary(io/filesystem
    PUBLIC
        ByteArrayRawFileSynchronizer
        ByteArrayRawFileSynchronizerFactory
    PRIVATE
        #   io/filesystem/externalbookmarkstorage
        ByteArrayRawFileLoadThread
        ByteArrayRawFilereloadThread
        ByteArrayRawFilewriteThread
        ByteArrayRawFileLoadJob
        ByteArrayRawFileConnectjob
        ByteArrayRawFileWriteJob
        ByteArrayRawFileReloadJob
        ByteArrayRawFileWriteToJob
)

# TODO: move to oktetacore, no longer duplicate
oktetakastencore_add_sublibrary(${LIBOKTETAWIDGETS_REL_DIR}
    PRIVATE
        ByteArrayChar8StringDecoder
        ByteArrayValueStringDecoder
)

okteta_add_library(Core NAMESPACE Okteta Kasten
    PUBLIC
        KastenCore
        OktetaCore
    PRIVATE
        KF5::I18n
        KF5::Bookmarks
    VERSION     ${OKTETAKASTENCORE_VERSION}
    SOVERSION   ${OKTETAKASTENCORE_SO_VERSION}
    ABIVERSION  ${OKTETAKASTEN_ABI_VERSION} ${KASTEN_ABI_VERSION}
    SOURCES   ${oktetakastencore_LIB_SRCS}
    HEADERS   ${oktetakastencore_LIB_HDRS}
    CCHEADERS ${oktetakastencore_LIB_CCHDRS}
    NO_TARGET_NAMESPACE
    NO_VERSIONED_INCLUDEDIR
    NO_VERSIONED_PACKAGE_NAME
    REVERSE_NAMESPACE_INCLUDEDIR
    REVERSE_NAMESPACE_LIB
)
target_include_directories(OktetaKastenCore
    PUBLIC
        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/document>
    PRIVATE
        ${LIBOKTETAWIDGETS_REL_DIR}
)


okteta_add_cmakeconfig(Core NAMESPACE Okteta Kasten
)

if(BUILD_TESTING)
  add_subdirectory(document/tests)
  add_subdirectory(io/tests)
endif()

=== libs/kasten/CMakeLists.txt ===
set( KASTEN_MAJOR_VERSION 0 )
set( KASTEN_MINOR_VERSION 4 )
set( KASTEN_PATCHLEVEL_VERSION 1 )
set( KASTEN_VERSION "${KASTEN_MAJOR_VERSION}.${KASTEN_MINOR_VERSION}.${KASTEN_PATCHLEVEL_VERSION}" )
set( KASTEN_ABI_VERSION 4 )

set( KASTEN_LIB_SOVERSION 0 )
set( KASTEN_LIB_VERSION ${KASTEN_VERSION} )

add_subdirectory( core )
add_subdirectory( gui )
add_subdirectory( controllers )

#add_subdirectory( kparts )

=== debian/changelog ===
okteta (5:0.26.24-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Update watch file to work with newer versions of uscan.
  * Drop Rules-Requires-Root: no, no more needed since Debian trixie.

 -- Pino Toscano <pino@debian.org>  Tue, 14 Oct 2025 09:09:25 +0200

okteta (5:0.26.23-2) unstable; urgency=medium

  * Team upload.
  * Update symbols files from the logs of buildds.

 -- Pino Toscano <pino@debian.org>  Tue, 12 Aug 2025 20:37:01 +0200

=== debian/control ===
Source: okteta
Section: kde
Priority: optional
Maintainer: Debian KDE Extras Team <pkg-kde-extras@lists.alioth.debian.org>
Uploaders: Aurélien COUDERC <coucouf@debian.org>,
Build-Depends: cmake (>= 3.16~),
               debhelper-compat (= 13),
               extra-cmake-modules (>= 5.48.0~),
               gettext,
               libkf5bookmarks-dev (>= 5.48.0~),
               libkf5codecs-dev (>= 5.48.0~),
               libkf5completion-dev (>= 5.48.0~),
               libkf5configwidgets-dev (>= 5.48.0~),
               libkf5crash-dev (>= 5.48.0~),
               libkf5dbusaddons-dev (>= 5.48.0~),
               libkf5doctools-dev (>= 5.48.0~),
               libkf5i18n-dev (>= 5.48.0~),
               libkf5iconthemes-dev (>= 5.48.0~),
               libkf5kcmutils-dev (>= 5.48.0~),
               libkf5kio-dev (>= 5.48.0~),
               libkf5newstuff-dev (>= 5.48.0~),
               libkf5parts-dev (>= 5.48.0~),
               libkf5service-dev (>= 5.48.0~),
               libkf5widgetsaddons-dev (>= 5.48.0~),
               libkf5xmlgui-dev (>= 5.48.0~),
               libqca-qt5-2-dev (>= 2.1.0),
               pkgconf,
               pkg-kde-tools (>= 0.15.23~),
               qtbase5-dev (>= 5.9.0~),
               qtdeclarative5-dev (>= 5.9.0~),
               qtscript5-dev (>= 5.9.0~),
               qttools5-dev (>= 5.9.0~),
               shared-mime-info (>= 0.30),
               xauth <!nocheck>,
               xvfb <!nocheck>,
Standards-Version: 4.7.2
Homepage: https://apps.kde.org/en/okteta
Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/okteta
Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/okteta.git

Package: libkasten4controllers0
Architecture: any
Section: libs
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: controllers Kasten library for Okteta
 Kasten is a framework for composing programs.
 .
 This package provides the controller part of Kasten.

Package: libkasten4core0
Architecture: any
Section: libs
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends},
         libokteta-l10n (>= ${source:Version}),
Description: core Kasten library for Okteta
 Kasten is a framework for composing programs.
 .
 This package provides the core part of Kasten.

Package: libkasten4gui0
Architecture: any
Section: libs
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: gui Kasten library for Okteta
 Kasten is a framework for composing programs.
 .
 This package provides the GUI part of Kasten.

Package: libkasten4okteta2controllers0
Architecture: any
Section: libs
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: kastencontrollers library for Okteta
 Okteta is a simple editor for the raw data of files. This type of program is
 also called hexadecimal editor or binary editor.
 .
 This package provides the part of the Okteta libraries interfacing with Kasten
 controllers.

Package: libkasten4okteta2core0
Architecture: any
Section: libs
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends},
         libokteta-l10n (>= ${source:Version}),
Description: kastencore library for Okteta
 Okteta is a simple editor for the raw data of files. This type of program is
 also called hexadecimal editor or binary editor.
 .
 This package provides the part of the Okteta libraries interfacing
 with Kasten core.

Package: libkasten4okteta2gui0
Architecture: any
Section: libs
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: kastengui library for Okteta
 Okteta is a simple editor for the raw data of files. This type of program is
 also called hexadecimal editor or binary editor.
 .
 This package provides the part of the Okteta libraries interfacing
 with Kasten GUI.

Package: libokteta3core0
Architecture: any
Section: libs
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends},
         libokteta-l10n (>= ${source:Version}),
Description: core Okteta library
 Okteta is a simple editor for the raw data of files. This type of program is
 also called hexadecimal editor or binary editor.
 .
 This package provides the core part of the Okteta libraries.

Package: libokteta3gui0
Architecture: any
Section: libs
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends},
         libokteta-l10n (>= ${source:Version}),
Description: gui Okteta library
 Okteta is a simple editor for the raw data of files. This type of program is
 also called hexadecimal editor or binary editor.
 .
 This package provides the GUI part of the Okteta libraries.

Package: libokteta-l10n
Architecture: all
Section: localization
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: translations of okteta/kasten libraries
 Okteta is a simple editor for the raw data of files. This type of program is
 also called hexadecimal editor or binary editor.
 .
 This package provides the translations for the various libokteta/libkasten
 libraries.

Package: okteta
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: hexadecimal editor for binary files
 Okteta is a simple editor for the raw data of files. This type of program is
 also called hexadecimal editor or binary editor.
 .
 The data is displayed in two variants: as the numeric values of the bytes
 and as the character assigned to the values. Values and characters can be
 shown either in two columns (the traditional display in hex editors) or in
 rows with the value on top of the character. Editing can be done both for
 the values and for the characters.
 .
 Besides the usual editing capabilities Okteta also brings a small set of
 tools, like a table listing decodings into common simple data types, a table
 listing all possible bytes with their character and value equivalents, an
 info view with a statistic, a checksum calculator, a filter tool and a string
 extraction tool.

Package: okteta-dev
Architecture: any
Section: devel
Depends: libkf5xmlgui-dev (>= 5.48.0~),
         qtbase5-dev (>= 5.9~),
         ${misc:Depends},
         ${shlibs:Depends},
         ${so:Depends},
Description: Development files for Okteta
 Okteta is a simple editor for the raw data of files. This type of program is
 also called hexadecimal editor or binary editor.
 .
 This package contains the development files for Okteta.

=== debian/rules ===
#!/usr/bin/make -f

# Disable fixfilepath, as it causes build failures.
export DEB_BUILD_MAINT_OPTIONS = hardening=+all reproducible=-fixfilepath

libpkgs_gen_strict_local_shlibs = $(libpkgs_all_packages)
include /usr/share/pkg-kde-tools/qt-kde-team/3/library-packages.mk

%:
	dh $@ --with kf5,pkgkde_symbolshelper,sodeps

override_dh_auto_configure:
	dh_auto_configure -Skf5 -- -DBUILD_TERMINALTOOL=OFF

override_dh_auto_test:
	xvfb-run -a --server-args="-screen 0 1024x768x24+32" dh_auto_test --no-parallel

override_dh_gencontrol-arch: libpkgs_gen_strict_local_shlibs
	dh_gencontrol -a

=== debian/watch ===
version=4
https://download.kde.org/stable/okteta/([\d.]+)/src/@PACKAGE@-([\d.]+)\.tar\.xz

## okteta 0.26.25

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 cmake_minimum_required(VERSION 3.16)
 
-project(Okteta VERSION 0.26.24)
+project(Okteta VERSION 0.26.25)
 
 set(REQUIRED_KF5_VERSION "5.48.0")
 find_package(ECM ${REQUIRED_KF5_VERSION} REQUIRED NO_MODULE)
@@ -130,6 +130,12 @@
     -DQT_NO_NARROWING_CONVERSIONS_IN_CONNECT
 )
 
+if(CMAKE_CXX_COMPILER_ID MATCHES "Clang")
+    # Not setting for GNU due to too many warnings related to private members of base classes or around lambdas
+    # see e.g. https://gcc.gnu.org/bugzilla/show_bug.cgi?id=56556 or https://gcc.gnu.org/bugzilla/show_bug.cgi?id=79328
+    string(APPEND CMAKE_CXX_FLAGS " -Wshadow")
+endif()
+
 # helper libs
 add_subdirectory( libs )
 if( BUILD_DESKTOPPROGRAM )

=== debian/changelog ===
okteta (5:0.26.25-2) unstable; urgency=medium

  [ Aurélien COUDERC ]
  * Recommend qml-module-org-kde-kcm, required for downloading
    structures from KNewStuff. (Closes: #1128962)
  * Use the new Extras team email as the maintainer.

 -- Aurélien COUDERC <coucouf@debian.org>  Thu, 26 Feb 2026 09:11:10 +0100

okteta (5:0.26.25-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Bump Standards-Version to 4.7.3, no changes required.
  * Drop Priority: optional, no more needed since dpkg 1.22.13.

 -- Pino Toscano <pino@debian.org>  Mon, 02 Feb 2026 23:45:22 +0100

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,6 @@
 Source: okteta
 Section: kde
-Priority: optional
-Maintainer: Debian KDE Extras Team <pkg-kde-extras@lists.alioth.debian.org>
+Maintainer: Debian KDE Extras Team <pkg-kde-extras@alioth-lists.debian.net>
 Uploaders: Aurélien COUDERC <coucouf@debian.org>,
 Build-Depends: cmake (>= 3.16~),
                debhelper-compat (= 13),
@@ -33,7 +32,7 @@
                shared-mime-info (>= 0.30),
                xauth <!nocheck>,
                xvfb <!nocheck>,
-Standards-Version: 4.7.2
+Standards-Version: 4.7.3
 Homepage: https://apps.kde.org/en/okteta
 Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/okteta
 Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/okteta.git
@@ -144,7 +143,9 @@
 
 Package: okteta
 Architecture: any
-Depends: ${misc:Depends}, ${shlibs:Depends}
+Depends: ${misc:Depends},
+         ${shlibs:Depends}
+Recommends: qml-module-org-kde-kcm,
 Description: hexadecimal editor for binary files
  Okteta is a simple editor for the raw data of files. This type of program is
  also called hexadecimal editor or binary editor.

## okteta 4.11.2

=== debian/control ===
Source: okteta
Section: kde
Priority: optional
Maintainer: Kubuntu Developers <kubuntu-devel@lists.ubuntu.com>
Build-Depends: kde-sc-dev-latest (>= 4:4.10.2),
 cmake, debhelper (>= 9), pkg-kde-tools (>= 0.12),
 kdelibs5-dev (>= 4:4.11.2),
 libqca2-dev,
 shared-mime-info,
 pkg-config 
Standards-Version: 3.9.4
Homepage: http://www.kde.org
Vcs-Browser: http://bazaar.launchpad.net/~kubuntu-packagers/kubuntu-packaging/okteta
Vcs-Bzr: https://code.launchpad.net/~kubuntu-packagers/kubuntu-packaging/okteta

Package: okteta
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: hexadecimal editor for binary files
 Okteta is a simple editor for the raw data of files. This type of program is
 also called hexadecimal editor or binary editor.
 .
 The data is displayed in the traditional view with two columns: one with the
 numeric values and one with the assigned characters. Editing can be done both
 in the value column and the character column. Besides the usual editing
 capabilities Okteta also brings a small set of tools, like a table listing
 decodings into common simple data types, a table listing all possible bytes
 with its character and value equivalents, a info view with a statistic and a
 filter tool. All modifications to the data loaded can be endlessly undone or
 redone.
 .
 This package is part of the KDE Software Development Kit module.

Package: okteta-dev
Architecture: any
Section: devel
Depends: okteta (= ${binary:Version}), ${misc:Depends},
 libkasten2controllers2abi1 (= ${binary:Version}), libkasten2core2 (= ${binary:Version}),
 libkasten2gui2 (= ${binary:Version}), libokteta1core1 (= ${binary:Version}),
 libokteta1gui1 (= ${binary:Version}), libkasten2okteta1controllers1abi1 (= ${binary:Version}),
 libkasten2okteta1core1 (= ${binary:Version}), libkasten2okteta1gui1 (= ${binary:Version})
Description: Development files for Okteta
 Okteta is a simple editor for the raw data of files. This type of program is
 also called hexadecimal editor or binary editor.
 .
 This package contains the development files for Okteta.
 .
 This package is part of the KDE Software Development Kit module.

Package: libkasten2controllers2abi1
Architecture: any
X-CMake-Target: kastencontrollers
Section: libs
X-Debian-ABI: 1
Depends: ${shlibs:Depends}, ${misc:Depends}
Replaces: okteta (<< 4:4.6)
Breaks: okteta (<< 4:4.6)
Description: controllers Kasten library for Okteta
 Kasten is a framework for composing programs.
 .
 This package is part of the KDE Software Development Kit module.

Package: libkasten2core2
Architecture: any
X-CMake-Target: kastencore
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Replaces: okteta (<< 4:4.6)
Breaks: okteta (<< 4:4.6)
Description: core Kasten library for Okteta
 Kasten is a framework for composing programs.
 .
 This package is part of the KDE Software Development Kit module.

Package: libkasten2gui2
Architecture: any
X-CMake-Target: kastengui
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Replaces: okteta (<< 4:4.6)
Breaks: okteta (<< 4:4.6)
Description: gui Kasten library for Okteta
 Kasten is a framework for composing programs.
 .
 This package is part of the KDE Software Development Kit module.

Package: libokteta1core1
Architecture: any
X-CMake-Target: oktetacore
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Replaces: okteta (<< 4:4.6)
Breaks: okteta (<< 4:4.6)
Description: core Okteta library
 Okteta is a simple editor for the raw data of files. This type of program is
 also called hexadecimal editor or binary editor.
 .
 This package is part of the KDE Software Development Kit module.

Package: libokteta1gui1
Architecture: any
X-CMake-Target: oktetagui
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Replaces: okteta (<< 4:4.6)
Breaks: okteta (<< 4:4.6)
Description: gui Okteta library
 Okteta is a simple editor for the raw data of files. This type of program is
 also called hexadecimal editor or binary editor.
 .
 This package is part of the KDE Software Development Kit module.

Package: libkasten2okteta1controllers1abi1
Architecture: any
X-CMake-Target: oktetakastencontrollers
X-Debian-ABI: 1
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Replaces: okteta (<< 4:4.6)
Breaks: okteta (<< 4:4.6)
Description: kastencontrollers library for Okteta
 Okteta is a simple editor for the raw data of files. This type of program is
 also called hexadecimal editor or binary editor.
 .
 This package is part of the KDE Software Development Kit module.

Package: libkasten2okteta1core1
Architecture: any
X-CMake-Target: oktetakastencore
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Replaces: okteta (<< 4:4.6)
Breaks: okteta (<< 4:4.6)
Description: kastencore library for Okteta
 Okteta is a simple editor for the raw data of files. This type of program is
 also called hexadecimal editor or binary editor.
 .
 This package is part of the KDE Software Development Kit module.

Package: libkasten2okteta1gui1
Architecture: any
X-CMake-Target: oktetakastengui
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Replaces: okteta (<< 4:4.6)
Breaks: okteta (<< 4:4.6)
Description: kastengui library for Okteta
 Okteta is a simple editor for the raw data of files. This type of program is
 also called hexadecimal editor or binary editor.
 .
 This package is part of the KDE Software Development Kit module.

Package: okteta-dbg
Section: debug
Architecture: any
Priority: extra
Depends: ${misc:Depends}, kde-runtime-dbg, kate-dbg
Replaces: kdeutils-dbg (<< 4:4.6), kdesdk-dbg
Breaks: kdeutils-dbg (<< 4:4.6), kdesdk-dbg
Suggests: okteta (= ${source:Version})
Description: debugging symbols for okteta
 This package contains debugging files used to investigate problems with
 binaries included in okteta.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/pkg-kde-tools/qt-kde-team/2/debian-qt-kde.mk

.PHONY: override_dh_auto_test

override_dh_install:
	$(overridden_command)
ifeq ($(DEB_HOST_ARCH_ENDIAN),little)
	dh_install --autodest -pokteta-dev usr/include/kasten2/okteta1/structtool.h
	dh_install --autodest -pokteta-dev usr/include/kasten2/okteta1/structtoolview.h
	dh_install --autodest -pokteta-dev usr/include/kasten2/okteta1/structurestoolfactory.h
	dh_install --autodest -pokteta-dev usr/include/kasten2/okteta1/structurestoolviewfactory.h
	dh_install --autodest -pokteta usr/share/kde4/config/okteta-structures.knsrc
endif

override_dh_strip:
	$(overridden_command) --dbg-package=okteta-dbg
